/*
 * Argus Client Software.  Tools to read, analyze and manage Argus data.
 * Copyright (c) 2000-2003 QoSient, LLC
 * All rights reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef RaSrvStats_h
#define RaSrvStats_h

#include <stdlib.h>

#include <errno.h>
#include <stdio.h>
#include <string.h>

#include <netinet/in.h>

#include <ctype.h>
#include <argus-namedb.h>
#include <argus_filter.h>
 
struct RaSrvHash {
   int srvProto, srvPort;
};

struct RaSrvHashTableHeader {
   struct RaSrvHashTableHeader *nxt, *prv;
   struct RaSrvHashTableStruct *htable;
   unsigned short hash;
   struct RaSrvHash srvhash;
   void *storeobj;
};

struct RaSrvHashTableStruct {
   int size, count;
   struct RaSrvHashTableHeader **array;
};

struct RaSrvHashTableStruct RaSrvHashTable;
struct RaSrvDescTableEntry *RaFindSrvHashObject (int, int);
struct RaSrvHashTableHeader *RaAddSrvHashEntry (struct RaSrvDescTableEntry *);
void RaRemoveSrvHashEntry (struct RaSrvHashTableHeader *);


void RaProcessQueue(struct RaQueueStruct *, unsigned char state);
#endif
